function  WWHBookData_AddTOCEntries(P)
{
var A=P.fN("Figures","2");
A=P.fN("Tables","3");
A=P.fN("BusinessEvents Resource Reference Tables","4");
A=P.fN("Preface","5");
var B=A.fN("Related Documentation","6");
var C=B.fN("TIBCO BusinessEvents Documentation","6#42561");
C=B.fN("TIBCO BusinessEvents Event Stream Processing","6#42620");
C=B.fN("TIBCO BusinessEvents Decision Manager","6#42650");
C=B.fN("TIBCO BusinessEvents Data Modeling","6#42673");
C=B.fN("TIBCO BusinessEvents Views","6#42702");
C=B.fN("Other TIBCO Product Documentation","6#42739");
B=A.fN("Typographical Conventions","7");
B=A.fN("How to Contact TIBCO Support","8");
A=P.fN("Introduction","9");
B=A.fN("Introduction","10");
A=P.fN("Project Tasks","11");
B=A.fN("Creating a Project","12");
B=A.fN("Finding a Project Element","13");
B=A.fN("Importing Projects from Earlier Versions","14");
C=B.fN("Importing a BusinessEvents 3.x Project into BusinessEvents Studio","14#2415115");
C=B.fN("Importing a BusinessEvents 3.x Project at the Command Line","14#2395675");
B=A.fN("Exporting (Generating) Concept and Event Schema (XSD) Files","15");
B=A.fN("Validating a Project","16");
B=A.fN("Adding External Libraries to the BusinessEvents Studio Classpath","17");
B=A.fN("Creating and Using Project Libraries","18");
C=B.fN("Creating a Project Library","18#2388622");
C=B.fN("Adding and Removing Project Libraries in a BusinessEvents Studio Project","18#2388661");
B=A.fN("Working with Global Variables","19");
C=B.fN("Adding and Managing Global Variables","19#2399563");
C=B.fN("Using Global Variables","19#2399579");
B=A.fN("Building an Enterprise Archive (EAR)","20");
C=B.fN("Building an EAR File in BusinessEvents Studio","20#2402059");
C=B.fN("Building an EAR File at the Command Line","20#2402074");
A=P.fN("Element Refactoring Operations","21");
B=A.fN("Renaming, Moving, Deleting, and Copy-Pasting Elements","22");
C=B.fN("Renaming, Moving, and Deleting Elements","22#2394920");
C=B.fN("Copy-Pasting an Element","22#2405668");
B=A.fN("Automatic Refactoring Actions and Limitations","23");
C=B.fN("Refactoring Limitations","23#2388839");
C=B.fN("Refactoring for Move and Rename Operations","23#2388845");
C=B.fN("Refactoring for Delete Operations","23#2388915");
A=P.fN("Channels and Destinations","24");
B=A.fN("Overview of Channels and Destinations","25");
C=B.fN("Types of Channels","25#2388510");
B=A.fN("Selecting a Serializer","26");
C=B.fN("Deploy-time Configuration","26#2388570");
B=A.fN("Mapping Incoming Messages to Non-default Events","27");
B=A.fN("Working with Rendezvous Channels","28");
C=B.fN("Rendezvous Message Header","28#2388638");
C=B.fN("Basic Serializer","28#2388644");
C=B.fN("Serializer For Use with Payloads","28#2388654");
B=A.fN("Working with Local Channels","29");
C=B.fN("Event Use Count","29#2388729");
C=B.fN("Using a Local Channel","29#2388736");
B=A.fN("Adding Channels and Destinations","30");
C=B.fN("Adding a Destination to a Channel","30#2388797");
B=A.fN("Communicating with Other Sources using TCP","31");
C=B.fN("APIs for TCP Communication","31#2407144");
B=A.fN("Channel Resource Reference","32");
C=B.fN("Configuration","32#2388853");
B=A.fN("Destination Resource Reference","33");
A=P.fN("JMS Channels","34");
B=A.fN("Selecting a JMS Serializer","35");
C=B.fN("BytesMessageSerializer","35#2389400");
C=B.fN("TextMessageSerializer","35#2389406");
B=A.fN("Creating Unique JMS DurableSubscriber Name Properties","36");
B=A.fN("Changing the JMS Message Acknowledgment Mode","37");
B=A.fN("Using JMS Header Properties in Incoming and Outgoing Messages","38");
C=B.fN("Setting Certain Header Properties in Destinations","38#2389606");
C=B.fN("Setting Header Properties Using Header Properties from Incoming JMS Messages","38#2389616");
C=B.fN("Setting JMS Header Properties in Outgoing JMS Messages Using Event Properties","38#2423100");
C=B.fN("How BusinessEvents Sets the JMSReplyTo Header in Outgoing Messages","38#2389654");
B=A.fN("JMS Header Field Names","39");
B=A.fN("Reconnecting to a JMS Server","40");
A=P.fN("HTTP and SOAP Channels","41");
B=A.fN("Overview of HTTP and SOAP Channels","42");
C=B.fN("Selecting the Server Type","42#2389908");
C=B.fN("SOAP Support","42#2389917");
B=A.fN("Working with HTTP Requests","43");
C=B.fN("Mapping of HTTP Requests to Events","43#2413446");
C=B.fN("Mapping of HTTP Request URI to Destination","43#2424389");
C=B.fN("Configuring BusinessEvents to Receive and Send HTTP Requests","43#2424048");
B=A.fN("HTTP Channel Configuration Properties","44");
C=B.fN("Defining Event Properties for Standard HTTP Header Properties","44#2416512");
B=A.fN("Using HTTP Functions to Configure HTTP Request Messages","45");
C=B.fN("Generating a Self-Signed SSL Certificate (Keystore)","45#2390251");
C=B.fN("Getting POST Data","45#2410756");
C=B.fN("Loading Trusted Certificates","45#2410184");
C=B.fN("Sending an Event","45#2410469");
C=B.fN("Sending an Asynchronous Request (Not Secure)","45#2411457");
C=B.fN("Sending a Secure Asynchronous Request","45#2410904");
C=B.fN("Sending a Secure Synchronous Request","45#2429581");
B=A.fN("Configuring BusinessEvents as a SOAP Server and Client","46");
C=B.fN("Overview of SOAP Related Resources","46#2390521");
C=B.fN("Mapping of SOAP Request URI to Destination","46#2424517");
C=B.fN("Manual Configuration","46#2390538");
C=B.fN("Using the WSDL Import Utility","46#2390571");
C=B.fN("Using the WSDL Export Utility","46#2398884");
B=A.fN("Parsing and Building SOAP Messages","47");
C=B.fN("Working with Incoming SOAP Messages (Event Payloads)","47#2390596");
C=B.fN("Working with Outgoing SOAP Messages (Event Payloads)","47#2390693");
B=A.fN("Understanding the WSDL to Project Resource Mapping","48");
C=B.fN("Example WSDL","48#2390733");
C=B.fN("Example Project Folder Structure","48#2390789");
C=B.fN("How Project Artifacts are Named","48#2390976");
A=P.fN("Simple Events","49");
B=A.fN("Overview of Simple Events","50");
C=B.fN("Using Inheritance","50#2388444");
B=A.fN("Adding a Simple Event","51");
B=A.fN("Simple Event Reference","52");
C=B.fN("Configuration (Standard Tab)","52#2388493");
C=B.fN("Properties (Standard Tab)","52#2388591");
C=B.fN("Metadata (Standard Tab)","52#2390838");
C=B.fN("Declaration and Expiry Action (Advanced Tab)","52#2390889");
C=B.fN("Payload (Advanced Tab)","52#2388639");
B=A.fN("Simple Event Attributes Reference","53");
A=P.fN("Time Events","54");
B=A.fN("Overview of Time Events","55");
C=B.fN("Scheduled Time Events","55#2388977");
C=B.fN("Rule Based Time Events","55#2388991");
B=A.fN("Working With Time Events","56");
C=B.fN("Adding a Time Event","56#2389004");
C=B.fN("Configuring a Rule Based Time Event in a Rule or Rule Function","56#2389030");
B=A.fN("TimeEvent Resource Reference","57");
C=B.fN("Configuration","57#2389059");
C=B.fN("Metadata","57#2389115");
B=A.fN("TimeEvent Attributes Reference","58");
B=A.fN("Rule Based TimeEvent Function Reference","59");
A=P.fN("Advisory Events","60");
B=A.fN("Working With Advisory Events","61");
C=B.fN("Uses of Advisory Events","61#2389256");
C=B.fN("Adding an Advisory Event to a Rule","61#2389305");
B=A.fN("Advisory Event Attributes Reference","62");
A=P.fN("Concepts","63");
B=A.fN("Overview of Concepts","64");
B=A.fN("Adding Concepts and Concept Relationships","65");
C=B.fN("Adding a Concept","65#2388447");
C=B.fN("Adding Concept Relationships","65#2388472");
B=A.fN("Concept Resource Reference","66");
C=B.fN("Configuration","66#2388531");
C=B.fN("Properties","66#2388596");
C=B.fN("Metadata","66#2388679");
B=A.fN("Concept Attributes Reference","67");
A=P.fN("Scorecards","68");
B=A.fN("Understanding and Working With Scorecards","69");
C=B.fN("Adding a Scorecard","69#2389047");
C=B.fN("Using a Scorecard in Rules","69#2389063");
C=B.fN("Scorecard Resource Reference","69#2389069");
A=P.fN("Domain Models","70");
B=A.fN("Overview of Domain Models","71");
C=B.fN("Domain Model Value Descriptions for User Friendly Presentation","71#2395278");
B=A.fN("Adding a Domain Model","72");
C=B.fN("Adding Domain Entries","72#2395321");
B=A.fN("Associating Domain Models with a Property","73");
B=A.fN("Validating Data in Domain Models","74");
A=P.fN("Shared Resources","75");
B=A.fN("Adding a Shared Resource","76");
C=B.fN("Adding a Shared Resource","76#1689077");
B=A.fN("HTTP Connection","77");
C=B.fN("Configuration","77#1675181");
C=B.fN("Configure SSL","77#1675233");
C=B.fN("Advanced","77#1684377");
B=A.fN("Identity Resource","78");
C=B.fN("Configuration","78#1678945");
B=A.fN("JDBC Connection","79");
C=B.fN("Configuration","79#1676047");
C=B.fN("Connection Pooling","79#1678425");
C=B.fN("Test Connection Button","79#1678434");
B=A.fN("JMS Application Properties","80");
C=B.fN("Configuration","80#1686687");
B=A.fN("JMS Connection","81");
C=B.fN("Configuration","81#1676395");
C=B.fN("Test Connection Button","81#1676595");
C=B.fN("Advanced Tab","81#1677771");
C=B.fN("Configure SSL","81#1676647");
B=A.fN("JNDI Configuration","82");
C=B.fN("Configuration","82#1676193");
C=B.fN("Advanced","82#1686977");
B=A.fN("Rendezvous Transport","83");
C=B.fN("Configuration","83#1677456");
C=B.fN("Configure SSL Button","83#1677570");
C=B.fN("Advanced","83#1677589");
A=P.fN("Rules and Rule Functions","84");
B=A.fN("Overview of Rules and Rule Functions","85");
C=B.fN("Form-based and Source Rule Editors","85#2388424");
C=B.fN("Rule Components","85#2410830");
C=B.fN("Using Events in Rules","85#2388431");
C=B.fN("Effect of Cache Only Cache Mode","85#2388457");
B=A.fN("Adding a Rule","86");
B=A.fN("Rule Editor Reference","87");
B=A.fN("Adding a Rule Function","88");
B=A.fN("Rule Function Resource Reference","89");
B=A.fN("Using Variables and Functions in the Rule Editor","90");
C=B.fN("Using Catalog Functions in the Rule Editor","90#2388664");
C=B.fN("Using Global Variables in the Rule Editor","90#2410449");
C=B.fN("Using the Function Argument Mapper","90#2410424");
B=A.fN("Using Priority and Rank to Control Order of Rule Execution","91");
B=A.fN("Tips for Working in the Rule Editor","92");
B=A.fN("Event Preprocessors","93");
C=B.fN("Configuring an Event Preprocessor","93#2388835");
A=P.fN("Functions","94");
B=A.fN("Overview of Catalog Functions","95");
C=B.fN("Built-in Functions","95#2389127");
C=B.fN("Custom Functions","95#2389204");
C=B.fN("Ontology Functions","95#2408518");
C=B.fN("Tool Tips","95#2408981");
C=B.fN("Decorations Indicating Where Functions can be Called","95#2389245");
C=B.fN("VRF Functions","95#2408386");
C=B.fN("Temporal Functions","95#2389372");
B=A.fN("Guidelines for Use of Coherence (Cache Query) Functions","96");
C=B.fN("Coherence Category","96#2389406");
C=B.fN("Constants and Extractors Categories","96#2389446");
C=B.fN("Filters Category","96#2389450");
C=B.fN("Query Category","96#2389460");
B=A.fN("Adding Custom Functions","97");
C=B.fN("Task Summary","97#2389504");
C=B.fN("Adding and Removing Custom Functions in a BusinessEvents Studio Project","97#2389548");
B=A.fN("Restrictions on Use of Custom Functions","98");
C=B.fN("Static and Non-Static Functions","98#2389587");
C=B.fN("Return Types","98#2389591");
C=B.fN("Name Overloading","98#2389603");
C=B.fN("Editing Custom Functions","98#2408062");
B=A.fN("Structure of a Function Catalog","99");
C=B.fN("Elements in the Function Catalog","99#2389634");
C=B.fN("Example Function Catalog","99#2389811");
A=P.fN("Rule Language Grammar","100");
B=A.fN("Rule Language Basics","101");
C=B.fN("Whitespace","101#2388419");
C=B.fN("Comments","101#2388430");
C=B.fN("Separators","101#2388440");
C=B.fN("Identifiers (Names)","101#2388461");
C=B.fN("Local Variables","101#2388488");
C=B.fN("Literals","101#2388656");
C=B.fN("Escape Sequences","101#2388673");
C=B.fN("Operators","101#2388719");
B=A.fN("Keywords and Other Reserved Words","102");
B=A.fN("Attributes","103");
B=A.fN("Accessing Concept and Event Properties","104");
C=B.fN("Concept Property Atom","104#2389073");
C=B.fN("Concept Property Array","104#2389117");
C=B.fN("Event Property","104#2389147");
B=A.fN("Exception Handling","105");
C=B.fN("Syntax","105#2389172");
C=B.fN("Examples","105#2391988");
B=A.fN("Flow Control","106");
C=B.fN("if/else","106#2389238");
C=B.fN("for","106#2389248");
C=B.fN("while","106#2389266");
A=P.fN("Rule Language Datatypes","107");
B=A.fN("Concept Properties to XML Datatype Conversions","108");
B=A.fN("Compatibility of Operators with Types","109");
B=A.fN("Correcting Inconsistencies of Type","110");
C=B.fN("String Operands","110#2389898");
C=B.fN("Arithmetic Expressions","110#2389906");
C=B.fN("Assignment Conversion","110#2389918");
C=B.fN("Function Argument Conversion","110#2389923");
A=P.fN("Mapping and Transforming Data","111");
B=A.fN("Overview of Mapping and Transformation","112");
C=B.fN("Function Section","112#1675214");
C=B.fN("Input Section","112#1675320");
C=B.fN("Mapping and Transforming Data to Function Input","112#1673125");
C=B.fN("Statements, Hints, and Errors","112#1673143");
B=A.fN("Buttons, Menus, and Icons","113");
C=B.fN("Toolbar and Right-Click Menu on the Input Section","113#1673164");
C=B.fN("Icons for Schema Element Datatypes","113#1673421");
C=B.fN("Qualifier Icons","113#1673513");
B=A.fN("Specifying Constants","114");
C=B.fN("Date and Datetime Strings in Constants","114#1673589");
B=A.fN("Data Validation","115");
B=A.fN("Repairing Incorrect Mappings","116");
B=A.fN("Shortcuts","117");
C=B.fN("Statement Menu Options","117#1673830");
C=B.fN("Dragging to the Left","117#1673842");
C=B.fN("Cutting and Pasting","117#1673863");
C=B.fN("Automatic Testing (at Runtime)","117#1689518");
B=A.fN("Examples of Mappings","118");
C=B.fN("Setting an Element Explicitly to Nil","118#1673960");
C=B.fN("Merging Input from Multiple Sources","118#1690538");
C=B.fN("Converting a List Into a Grouped List","118#1690596");
C=B.fN("Merging Two Corresponding Lists","118#1690641");
C=B.fN("Coercions","118#1690688");
B=A.fN("XSLT Statements","119");
C=B.fN("Attribute","119#1674179");
C=B.fN("Choose","119#1674190");
C=B.fN("Comment","119#1674203");
C=B.fN("Copy","119#1674208");
C=B.fN("Copy-Contents-Of","119#1674213");
C=B.fN("Copy-Of","119#1674221");
C=B.fN("Element","119#1674226");
C=B.fN("For-Each","119#1674231");
C=B.fN("For-Each-Group","119#1691123");
C=B.fN("Generate Comment","119#1674249");
C=B.fN("Generate PI","119#1674254");
C=B.fN("If","119#1674259");
C=B.fN("Value-Of","119#1674270");
C=B.fN("Variable","119#1674275");
A=P.fN("XPath Formula Builder","120");
B=A.fN("XPath Basics","121");
C=B.fN("Addressing Schema Elements","121#1674314");
C=B.fN("Evaluation Context","121#1674328");
C=B.fN("Namespaces","121#1674331");
C=B.fN("Search Predicates","121#1674336");
C=B.fN("Testing for Nil","121#1674352");
C=B.fN("Comments","121#1674356");
B=A.fN("The XPath Formula Builder","122");
B=A.fN("String Representations of Datatypes","123");
B=A.fN("Date and Time Functions","124");
A=P.fN("ActiveMatrix BusinessWorks Integration","125");
B=A.fN("Overview of Integration with ActiveMatrix BusinessWorks","126");
C=B.fN("The Container and the Contained Engine","126#1689318");
B=A.fN("Integration Components","127");
C=B.fN("ActiveMatrix BusinessWorks Activities Palette","127#1685099");
C=B.fN("BusinessEvents Functions","127#1675416");
B=A.fN("Design Considerations","128");
C=B.fN("Integration Scope","128#1675856");
C=B.fN("Thread Management","128#1675872");
C=B.fN("Design Considerations Related to Container","128#1675922");
C=B.fN("Fault Tolerance With a BusinessEvents Container","128#1676057");
C=B.fN("Tips for Working With ActiveMatrix BusinessWorks Containers","128#1676085");
B=A.fN("Configuring the Environment for ActiveMatrix BusinessWorks Containers","129");
B=A.fN("Configuring the Environment For BusinessEvents Containers","130");
B=A.fN("Configuring a RuleServiceProvider Configuration Resource","131");
B=A.fN("BusinessEvents RuleServiceProvider Configuration Resource Reference","132");
C=B.fN("Configuration","132#1692254");
B=A.fN("Working With the BusinessEvents Activities","133");
B=A.fN("Receive Event Resource Reference","134");
C=B.fN("Configuration","134#1679527");
C=B.fN("Misc","134#1679563");
C=B.fN("Output","134#1679587");
B=A.fN("Send Event Resource Reference","135");
C=B.fN("Configuration","135#1679613");
C=B.fN("Input","135#1688859");
B=A.fN("Wait for Event Resource Reference","136");
C=B.fN("Configuration","136#1679673");
C=B.fN("Event","136#1679709");
C=B.fN("Input","136#1679737");
C=B.fN("Output","136#1679759");
B=A.fN("Invoking a BusinessEvents Rule Function from a Process","137");
C=B.fN("Specifying Input Arguments","137#1682500");
C=B.fN("Using Synchronous Invocation","137#1682514");
C=B.fN("Using the lockWM Parameter","137#1682525");
C=B.fN("Overriding the Rule Function at Runtime","137#1682537");
B=A.fN("Working With Invoke RuleFunction Activities","138");
B=A.fN("Invoke RuleFunction Resource Reference","139");
C=B.fN("Configuration","139#1682612");
C=B.fN("Input","139#1682665");
C=B.fN("Output","139#1682710");
B=A.fN("Working With the BusinessWorks Functions","140");
C=B.fN("Using invokeProcess()","140#1682733");
C=B.fN("Using startProcess()","140#1682832");
C=B.fN("Using cancelProcess()","140#1682926");
C=B.fN("Using init()","140#1682934");
C=B.fN("Using shutdown()","140#1682962");
A=P.fN("BusinessEvents Performance Profiler","141");
B=A.fN("Overview of Profiler","142");
B=A.fN("Working With the Profiler","143");
C=B.fN("To Turn Profiler On and Off Using Properties","143#2389345");
C=B.fN("To Turn Profiler On and Off Using Functions","143#2388555");
C=B.fN("To Turn Profiler On and Off Using TIBCO Hawk Methods","143#2388597");
B=A.fN("Profiler Reference","144");
A=P.fN("Tester","145");
B=A.fN("Overview","146");
B=A.fN("Preparing to Run the Tester","147");
B=A.fN("Launch Configurations Reference","148");
C=B.fN("For Local Testing","148#2397042");
C=B.fN("For Remote Testing","148#2397091");
B=A.fN("Running the Tester","149");
B=A.fN("Viewing the Results","150");
A=P.fN("Debugger","151");
B=A.fN("Overview","152");
B=A.fN("Preparing to Run Debugger","153");
B=A.fN("Launch Configurations Reference","154");
C=B.fN("For Local Debugging","154#2390492");
C=B.fN("For Remote Debugging","154#2390734");
B=A.fN("Configuring a BusinessEvents Engine for Remote Debugging","155");
B=A.fN("Running the Debugger","156");
A=P.fN("Diagrams","157");
B=A.fN("Overview of Diagrams","158");
B=A.fN("Working with Diagrams","159");
C=B.fN("Performing Common Tasks","159#2443447");
C=B.fN("Using Diagram Tools","159#2443544");
C=B.fN("Exporting a Diagram to an Image","159#2449143");
C=B.fN("Printing a Diagram","159#2449159");
C=B.fN("Setting Diagram Preferences","159#2452670");
B=A.fN("Project Analyzer and Selected Entity Project Diagrams","160");
C=B.fN("Advantages of Project Analyzer and Selected Entity Project Diagrams","160#2447245");
C=B.fN("Working with Project Analyzer and Selected Entity Project Diagrams","160#2447272");
B=A.fN("Dependency Diagrams","161");
B=A.fN("Sequence Diagrams","162");
B=A.fN("Concept Model Diagrams","163");
B=A.fN("Event Model Diagrams","164");
B=A.fN("Diagram Tools Reference","165");
C=B.fN("Layout Options","165#2419550");
B=A.fN("Reference to Diagram Preferences","166");
A=P.fN("Handling Null Properties","167");
B=A.fN("Handling Null Concept Property Values","168");
C=B.fN("Enabling Use of the Nillable Attribute","168#1675329");
C=B.fN("Enabling Null Property Values to Appear When Serializing Concepts to XML","168#1674864");
C=B.fN("Examples of Nillable Attribute and Null Properties Settings","168#1674872");
C=B.fN("Enabling and Setting Special Treatment of Numeric Null Values","168#1674903");
C=B.fN("Setting Runtime Properties for Special Treatment of Null Values","168#1674966");
C=B.fN("Property Reference for Null Property Handling","168#1674993");
}
